//@oleksandr17
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.security.NoSuchAlgorithmException;

public class Habr {
    private static final double C = 299792458.;
    private static final double por = 10000000.;
    
    private static double dist(double x, double y) {
        return x*x + y*y;
    }
    
    private static Boolean checkPoint(double diff, double x, double y, double x1, double y1) {
        double len = Math.sqrt((x-x1) * (x-x1) + (y-y1) * (y-y1));
        double tm = len / C;
        return Math.abs(diff - tm * por) < 25;
    }
    
    public static void main(String[] args) throws IOException, NoSuchAlgorithmException {     
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int n = new Integer(in.readLine());
        Double x[]=new Double[4],y[]=new Double[4];
        Integer p[] = new Integer[3];
        
        n = Math.min(3, n);
        
        for(int i=0; i<n; i++) {
            x[i] = new Double(in.readLine());
            y[i] = new Double(in.readLine());
            String s = in.readLine();
            int cnt = 1; 
            char ch = s.charAt(0);
            int pos = 0;
            for(int j=10; j<s.length(); j+=10) {
                if ( s.charAt(j) != ch ){
                    if(cnt >= 18) {
                        pos = j;
                        break;
                    }
                    ch = s.charAt(j);
                    cnt = 1;
                } else {
                    cnt++;
                }
            }
            
            if (ch == '1') {
                p[i] = pos/10 - 637567;
            } else {
                p[i] = pos/10 - 42758;
            }
            if(p[i] < 0) p[i] += 1000000;
        }
        
        double r1 = 10. * p[0] * C / por;
        double r2 = 10. * p[1] * C / por;
        
        x[1] -= x[0];
        y[1] -= y[0];
        
        double r = r1, a = -2.0 * x[1], b = -2. * y[1], c = 1.*x[1] * x[1] + 1.*y[1] * y[1] + r1 * r1 - r2 * r2; 

        double x0 = -a*c/(a*a+b*b),  y0 = -b*c/(a*a+b*b);
        double EPS = 100.0;
        if (Math.abs (c*c - r*r*(a*a+b*b)) < EPS) {
                System.out.println(x0 + ' ' + y0);
        } else {
                double d = r*r - c*c/(a*a+b*b);
                double mult = Math.sqrt (d / (a*a+b*b));
                double ax,ay,bx,by;
                ax = x0 + b * mult;
                bx = x0 - b * mult;
                ay = y0 - a * mult;
                by = y0 + a * mult;
                
                double x1 = ax + x[0];
                double y1 = ay + y[0];
 
                double x2 = bx + x[0];
                double y2 = by + y[0];
                
                if (n == 2) {
                    if (dist(x1, y1) < dist(x2, y2) ) {
                        System.out.println(x1 + " " + y1);
                    } else {
                        System.out.println(x2 + " " + y2);
                    }
                    return;
                } 
                if (checkPoint(p[2], x[2], y[2], x1, y1)){
                    System.out.println(x1 + " " + y1);
                } else {
                    System.out.println(x2 + " " + y2);
                }
        }
    }
    
}
